import heapq
import sys
import random
import networkx as nx
import math
import string
import time
import scipy as sci
import numpy as np
import os.path
from Queue import Queue
import time
from scipy.sparse.linalg import eigsh

def merge_infected_node(G,Iset):
   #add new edge, give weights 
    I=0

    G.add_node(I)
    G1=G.copy()
    #printline(G)
    for node in Iset:
        for nbr in nx.all_neighbors(G, node):
            w=G[node][nbr]['weight']
            if G1.has_edge(I,nbr)==False:
                G1.add_edge(I,nbr,weight=w)
            else:
                temp=G1[I][nbr]['weight']
                G1[I][nbr]['weight']=0
    #remove nodes
    G=G1
    for node in Iset:
        if node in G:
            G.remove_node(node)
    G1=G
    if G1.has_edge(I,I):
        G1.remove_edge(I,I)
    return [G1,I]

def read_infected_node(filename):
    infected_set=[]
    f=open(filename,'r')
    lines=f.readlines()
    for line in lines:
        infected_set.append(int(line))
    f.close()
    return infected_set    
    
def create_undirected_graph_IC(filename):
    g=nx.Graph()
    
    f=open(filename,'r')
    lines=f.readlines()
    for line in lines:
        #[node1, node2, weight]=line.split()
        #index1=int(node1)
        #index2=int(node2)
        #weight=eval(weight)
        temp=line.split()
        index1=int(temp[0])
        index2=int(temp[1])
        weight=0
        g.add_edge(index1,index2,weight=weight) 
    
    #for n,nbrs in g.adjacency_iter():
        #for nbr, weight in nbrs.items():
            #print("%d,%d,%d" %(n,nbr,weight['weight']))
            #a=1        
    f.close()   
    return g
    
def create_seeds(seed_file,G_orig, seednum):
    f=open(seed_file,'w')
    seeds=random.sample(range(1,len(G_orig)+1), seednum)
    for seed in seeds:
        f.write("%d\n" % seed)
    f.close()
    
def get_live_graph(G):
    #g=nx.DiGraph()
    g=nx.Graph()
    for node in G.nodes():
        neis=(G[node]).keys()
        neis.append(-1)
        sample=random.sample(neis, 1)
        sample=sample[0]
        if sample!=-1:
            g.add_edge(node,sample, weight=0)
    return g

def edge_deletion_LT(edgelist_name, groupname, K,simulations):
    '''
    edgelist_name: group filename
    groupname: group filename
    K: k groups
    Return: S: selected sequence; vacc_distribution: vector of allocation
    '''
    save_file=edgelist_name+"_LT_edge_group_selected_"+str(K)+"_"+str(int(time.time()))
    f=open(save_file,'w')
    f.close()
    #undirectd graph (networkx format)
    G_orig=create_undirected_graph_IC(edgelist_name)
    
    #if seed not exist, create the seed
    seed_file=edgelist_name+"_seeds"
    if os.path.exists(seed_file)==False:
        seednum=int(len(G_orig)*0.01)
        if seednum==0:
            seednum=5
        create_seeds(seed_file,G_orig, seednum)
    
    #g=G_orig.copy()
    
    #group_dict
    group_dict={}
    f=open(groupname,'r')
    lines=f.readlines()
    f.close()
    for line in lines:
        temp_list=line.split()
        node_str_list=temp_list[1:]
        node_list=[]
        for x in node_str_list:
            node_list.append(int(x))

        group_dict[int(temp_list[0])]=node_list
    
    #inverted index
    node_dict={}
    for node in G_orig.nodes():
        node_dict[(node)]=[]
    for key in group_dict.keys():
        node_list=group_dict[key]
        for node in node_list:
            node_dict[node].append(key)
    num_node=len(node_dict)
    
    print "Edge Deletion LT"
    start_time=time.time()
    #S: sequence to distribute vaccine
    S=[]
    vacc_distribution=[0]*(len(group_dict)+1)
    
    #Merge seeds
    infected_set=read_infected_node(seed_file)
    [G,I]=merge_infected_node(G_orig,infected_set)
    
    #live graphs
    live_graphs=[]
    ru=[]
    parent=[]
    for i in range(simulations):
        liveG=get_live_graph(G)
        live_graphs.append(liveG)
        ru.append({})
        parent.append({})
    #get the initial footprint for all nodes=0
    for i in range(simulations):
        [ru[i],parent[i],G]=get_footprint_for_each_node(live_graphs[i], G, I)
    for j in range(K):
        #delta_e for the group
        max=-9999999999999999
        group_index=0
        edge=(-1,-1)
        for group in group_dict:
            node_list=group_dict[group]
            node=random.sample(node_list, 1)
            node=node[0]
            while node not in G:
                node=random.sample(node_list, 1)
                node=node[0]
            neilist=G[node].keys()
            if len(neilist)!=0:

                nei=random.sample( ((G[node]).keys()),1)

                nei=nei[0]
                while nei not in G:
                    nei=random.sample( ((G[node]).keys()),1)
                    nei=nei[0]
                delta=G[node][nei]['weight']
            else:
                delta=max-1
            #print delta
            if delta>max:
                max=delta
                group_index=group
                edge=(node,nei)
        #select group_index
        print "%d th selection is:%d" % (j, group_index)
        S.append(group_index)
        #(edgelist_name, groupname, K,simulations)
        
        f=open(save_file,'a')
        f.write("%d\n" % group_index)
        f.close()
        
        vacc_distribution[group_index]=vacc_distribution[group_index]+1
        (ut,vt)=edge
        if G.has_edge(ut,vt):
            G.remove_edge(ut,vt)
       
        print edge
        for i in range(len(live_graphs)):
            live_graph=live_graphs[i]
            if live_graph.has_edge(ut,vt):
                s=ut
                while s!=I and s!=-1:
                    ru[i][s]=ru[i][s]-ru[i][vt]-1
                    if G.has_edge(parent[i][s],s):
                        G[parent[i][s]][s]['weight']=G[parent[i][s]][s]['weight']-ru[i][vt]-1
                    s=parent[i][s]
                Q=Queue()
                Q.put(ut)
                visited={}
                visited[ut]=True
                while Q.empty()==False:
                    s=Q.get()
                    s_nei= ((G[s]).keys())
                    for u in s_nei:
                        if u not in visited:
                            visited[u]=True
                            Q.put(u)
                            G[s][u]['weight']=G[s][u]['weight']-1
                            ru[i][s]=0
                            ru[i][u]=0
                
    end_time=time.time()
    cost_time=end_time-start_time
   
    return [S,vacc_distribution, cost_time]

def get_footprint_for_each_node(live_graph, G, a):
    ru={}
    parent={}
    for node in G.nodes():
        ru[node]=0
        parent[node]=-1
    g=G
    #stack H, queue Q
    H=[]
    Q=Queue()
    visited={}
    visited[a]=True
    Q.put(a)
    while Q.empty()==False:
        s=Q.get()
        s_nei=((live_graph[s]).keys())
        for u in s_nei:
            if u not in visited:
                visited[u]=True
                Q.put(u)
                H.append((s,u))
                parent[u]=s
    while len(H)>0:
        (u,v)=H.pop()
        ru[u]=ru[u]+ru[v]+1
        g[u][v]['weight']=g[u][v]['weight']+ru[v]+1
    return [ru,parent,g]

def get_final_footprint_edge_deletion(edgelist_name, group_name,S, simulations):
    footprint=0
    #undirectd graph (networkx format)
    G_orig=create_undirected_graph_IC(edgelist_name)
   
    
    #group_dict
    group_dict={}
    f=open(group_name,'r')
    lines=f.readlines()
    f.close()
    for line in lines:
        temp_list=line.split()
        node_str_list=temp_list[1:]
        node_list=[int(x) for x in node_str_list]

        group_dict[int(temp_list[0])]=node_list
    
    #inverted index
    node_dict={}
    for node in G_orig.nodes():
        node_dict[(node)]=[]
    for key in group_dict.keys():
        node_list=group_dict[key]
        for node in node_list:
            node_dict[node].append(key)
    num_node=len(node_dict)
    
    print "get_footprint"
   
    
    #Merge seeds
    seed_file=edgelist_name+"_seeds"
    infected_set=read_infected_node(seed_file)
    [G,I]=merge_infected_node(G_orig,infected_set)
    
    #live graphs
    live_graphs=[]
    ru=[]
    parent=[]
    for i in range(simulations):
        liveG=get_live_graph(G)
        live_graphs.append(liveG)
        ru.append({})
        parent.append({})
    #remove edge from group
    for group in S:
        node=random.sample(group_dict[group],1)
        node=node[0]
        while node not in G:
            node=random.sample(group_dict[group],1)
            node=node[0]
        neis=G[node].keys()
        nei=random.sample(neis,1)
        nei=nei[0]
        while nei not in G:
            print "nei not in G in final footprint"
            nei=random.sample(neis,1)
            nei=nei[0]
        for live_graph in live_graphs: 
            if live_graph.has_edge(node,nei):
                live_graph.remove_edge(node,nei)
    
        
        
    #get the initial footprint for all nodes=0
    for i in range(simulations):
        [ru[i],parent[i],G]=get_footprint_for_each_node(live_graphs[i], G, I)
        print "the %i th footprint in (%d) is %d " % (i, len(live_graphs[i]),ru[i][I])
    
    for i in range(simulations):
        footprint=footprint+ru[i][I]
    footprint=footprint*1.0/simulations
    footprint=footprint+len(infected_set)-1
    return footprint
    
def main():
    '''
    filename: edgelist 1 2 0.5
    groupname: group_id (start from 1) member1 member2
    '''
    edgelist_name=sys.argv[1]
    groupname=sys.argv[2]
    K=int(sys.argv[3])
    simulations=int(sys.argv[4])    
    
    [S,vacc_distribution, cost_time]=edge_deletion_LT(edgelist_name, groupname, K, simulations)
    footprint=get_final_footprint_edge_deletion(edgelist_name, groupname,S[:K], simulations)
    print "footprint is %f:" %footprint
    print cost_time
    #selected_groups.sort()
    print S
    #print vacc_distribution
    cost_time_file=edgelist_name+"_cost_time_LT_edge_"+str(K)+"_"+str(simulations)
    f=open(cost_time_file, 'w')
    f.write("%f\n" % cost_time )
    f.close()
    

if __name__=='__main__':
    main()
